#ifndef STRONG_CLASSIFIER_H
#define STRONG_CLASSIFIER_H

#include "weak_classifier.h"
//#include <boost/archive/text_oarchive.hpp>
//#include <boost/archive/text_iarchive.hpp>

namespace mimas{

/**
 *
 *
 *
 *
 *
 * Time-stamp: <2005-08-03 19:03:23 engmb>
 * Copyright (C) 2005 by Manuel Boissenin
 *
 * @author Manuel Boissenin
 * @date 03/08/2005
 *
 ***********************************************************************/


  
  class strong_classifier
    {
    public:
      //we store our result classifier in a different class
      class haar_classifier{
      public:
	float threshold;
	direction_t threshold_direction;
	haar_feature feature;
	double weight;
	
	haar_classifier(weak_classifier & best_wc)
	  :threshold(best_wc.threshold),threshold_direction(best_wc.threshold_direction),feature(best_wc.feature)
	  {
	    weight = log((1 - best_wc.error_measure)/ best_wc.error_measure);
	    std::cerr<<"classifier weight = "<< weight << std::endl; 
	  }
	/*
      private:	
	friend class boost::serialization::access;

	template<class Archive>
	  void serialize(Archive & ar, const unsigned int version)
	  {
	    ar & threshold;
	    ar & threshold_direction;
	    ar & feature;
	    ar & weight;
	  }

	*/
      };

      double stg_threshold;
      std::vector<haar_classifier> haar_classifiers;
      
      void add(weak_classifier &good_wc)
	{
	  haar_classifiers.push_back(haar_classifier(good_wc));
	}

      void calculate_threshold(void)
	{
	  stg_threshold = 0.;
	  for(std::vector<haar_classifier>::iterator it = haar_classifiers.begin(); it!= haar_classifiers.end(); it++)
	    {
	      stg_threshold += it->weight;
	    }
	  stg_threshold /= 2.;
	}

      bool detect(integral_image &i_image, int x, int y, float factor = 1.)
	{
	  //!!optimisation check fo bounds here instead of inside the for loop	    
	  double measure = .0;
	  for(std::vector<haar_classifier>::iterator it = haar_classifiers.begin(); it!= haar_classifiers.end(); it++)
	    {
	      try
		{
		  if(it->threshold * it->threshold_direction <= it->feature.measure(i_image, x, y, factor) * it->threshold_direction)
		    measure += it->weight;
		}
	      catch(std::string & msg)
		{
		  //std::cerr<< msg<<std::endl;
		  return false;
		}
	    }

	 if( measure != 0)
	   {
	     //std::cerr << "measured value: " << measure <<std::endl;
	     //std::cerr << "threshold value: " << stg_threshold <<std::endl;
	   }
	  
	 if(measure >= stg_threshold)
	   return true;
	 return false;
	}

      /*
    private:
      friend class boost::serialization::access;
      
      template<class Archive>
	void serialize(Archive & ar, const unsigned int version)
	{
	  ar & stg_threshold;
	  ar & ;
	}
      */
    };

}
#endif
