//
// Example usages of the Haynes and Jain edge detector
// $Header: /cvs/mimas2/examples/hj/main.cc,v 1.1.1.1 2005/08/09 15:37:29 engmb Exp $
//
// IMPORTANT NOTE:
// 	when calling edgeHaynesJain(image1,image2,outimage)
//  image1 = image at time t-1
//  image2 = image at time t
//

#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"

using namespace std; 
using namespace mimas;

int	main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;

    image<int> image1, image2, outimage;
    image_mesaoutput< unsigned char > windows( &display );

   ifstream file1( "grabbed0090.pgm", ios::binary );
   file1 >> image1;
   ifstream file2( "grabbed0091.pgm", ios::binary );
   file2 >> image2;

	outimage = edgeHaynesJain( image1, image2 );
	normaliseIt(outimage,0,255);
	bilevelIt( outimage, 5, 0, 255 );
   
	windows << outimage << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}


