#include <iostream>
#include <fstream>
#include <sstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mplayeroutput.h"

using namespace std;
using namespace mimas;

/**
 * Example usage of the mplayer output
 * Note that you need mplayer installed.
 * @author Bala Amavasai (bala@amavasai.org)
 * @date Tue May 18 14:55:46 BST 2004
 * $Header: /cvs/mimas2/examples/display/main.cc,v 1.1.1.1 2005/08/09 15:37:31 engmb Exp $
 */

int main(void)
{
  int retVal = 0;

  try {

	image< rgba< unsigned char > > img[4];

   for ( int i=0; i<4; i++ ) {
    ostringstream fileName;
    fileName << "../images/sequences/stuart/stu" << i << ".ppm";
    ifstream stuFile( fileName.str().c_str(), ios::binary );
    stuFile >> img[i];
  };   

#ifdef HAVE_MKSTEMP
  image_mplayeroutput< rgba< unsigned char > > disp
    ( img[0].getWidth(), img[0].getHeight() );
   
	// open a display that will stream to an MPEG4 avi file. This 
	// requires the yet to be released MPlayer 1.0 to be installed.
	// But see code if you want to use it:
	//disp.open(img[0].getWidth(),img[0].getHeight(), "output.avi");

	for (int a=0; a<40; a++)
     disp << img[ a % 4 ];
#endif

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };

  return retVal;
}



