#ifndef IMAGE_FILESINPUT_TCC
#define IMAGE_FILESINPUT_TCC

#include <fstream>

namespace mimas {

template< typename T >
void image_filesinput< T >::read( image< T > &image )
  throw (mimasexception)
{
  MMERROR( image_filesinput< T >::state, mimasexception, ,
	   "Attempt to read image, after image_filesinput indicated end "
	   "of file-list." );

  if ( fileNames.empty() )
    image_filesinput< T >::state = false;
  else {
    std::string fileName = fileNames.front();
    fileNames.pop_front();
    std::ifstream file( fileName.c_str(), std::ios::binary );
    MMERROR( file >> image, mimasexception, ,
             "Error loading file \"" << fileName << "\"." );
  };
}

};

#endif
