//
// line structures
//
// stuart meikle
//Thu Mar  2 10:42:32 2000
//

// future improvement (?) we could make line a subclass of vector 
// as a vector is a line which starts at 0,0 ! maybe vector should be a subclass of
// line , etc ,etc

#ifndef LINE_H
#define LINE_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/smart_ptr.hpp>
#include <list>
#include "object.h"
#include "angle.h"

namespace mimas {
/** updated by stu 20030228. removing the vectors-as-pointers. this cuts down on the
    number of new's and delete's we need to do and speed things up loads.
    Ive removed the base class too for now. there doesn't really seem to be much need
    for it, and again, it slows down construction times.

    I'll leave you to work this one out. There should be lots of overloaded
    operators for lines too, but i havent got around to it yet. */
class line
{
    public:
  typedef boost::numeric::ublas::vector< double > Vector;
    private:
	// i don't think we'll need a co-ordinate system description for a line?
	// or maybe we do . i don't know. perhaps the co-ordinate system description
	// goes into object base class ?

  Vector start,end;

    public:
   line(void): start(2), end(2)
	{
	}

   line( double sx, double sy, double ex, double ey ): start( 2 ), end( 2 )
	{
     start(0) = sx; start(1) = sy;
     end  (0) = ex; end  (1) = ey;
	}

   line( const Vector &_start, const Vector &_end ):
     start( _start ), end( _end ) {}

	//WARNING ! use getVector().unit() to do a tina-like line->v command
   Vector getVector( void ) const
	{
     return end - start;
	}

   Vector findMidPoint(void) const
	{
     return 0.5 * ( start + end );
	}

	// vector	rotate( angle a );
	Vector getIntersection( const line &l2, bool *on_this_line, bool *on_that_line ) const;
   Vector getIntersectionAngle( const line &l2, angle *retval) const;
	const Vector &getStart(void) const { return start; }
	const Vector &getEnd(void) const { return end; }
	Vector &getStart(void) { return start; }
	Vector &getEnd(void) { return end; }
	double length(void) const { return norm_2( end - start ); }
	angle getAngle( const line &l ) const;
	//line&	operator=( const line& a );

};

///
typedef boost::shared_ptr< line > line_ptr;

///
typedef std::list< line_ptr > line_ptr_list;

///
typedef boost::shared_ptr< line_ptr_list > line_ptr_list_ptr;

};
#endif

