#ifndef POL_MATCH_H
#define  POL_MATCH_H

#include <boost/numeric/ublas/vector.hpp>
#include <boost/shared_ptr.hpp>
#include "angle.h"
#include <list>

namespace mimas {
class pol_model;
 
/**
 *
 * a simple structure used to store the found models in the scene
 * (the matches!)
 *
 * stumeikle Mon 04 Nov 2002 17:30:22 CET
 *
 * $Header: /cvs/mimas2/include/pol_match.h,v 1.1.1.1 2005/08/09 15:37:45 engmb Exp $
 */
class	pol_match
{
    public:
   typedef boost::numeric::ublas::vector< double > Vector;
	pol_model	*model_found;	///< is this used??
	Vector pos;		///< position of centroid of model
	angle	orient;		///< orientation
	double		strength;	///< strength of match. higher==better match found
	double		scale;		///< the scale of the match.

    pol_match()
    { model_found=NULL; strength=0; scale=1.0;}
    
    void	setPosition( const Vector &v )
		{ pos=v;}
    const Vector &getPosition() const
		{ return pos; }
    void	setOrientation( const angle &a )
		{orient=a;}
    const angle	&getOrientation() const
		{return orient;}
    void	setStrength(double d)
		{strength=d;}
    double	getScale(void) const
    		{ return scale; }
    void	setScale(double d)
    		{ scale=d; }

};

///
typedef boost::shared_ptr< pol_match > pol_match_ptr;

///
typedef std::list< pol_match_ptr > pol_match_ptr_list;

}

#endif
