#ifndef __VECTORFIELD_TCC
#define __VECTORFIELD_TCC

namespace mimas {

template< class Tensor >
vectorfield< Tensor >::vectorfield( int width, int height,
                                          const Tensor &aTensor ):
  data( boost::extents[ height ][ width ] )
{
  double
    cx = 0.5 * width,
    cy = 0.5 * height;
  // Precompute data.
  for ( int y=0; y<height; y++ )
    for ( int x=0; x<width; x++ ) {
      Vector v( 2 );
      v(0) = x - cx;
      v(1) = y - cy;
      data[ y ][ x ] = aTensor( v );
    };
}

};

#endif
