//
// angle stuff
//

#include <cmath>
#include "angle.h"

namespace mimas {

void angle::arcTan2(double y, double x)
{
   if (y==0.0)
   {
      if (x>0.0)
      {
         _angle = 0.0;
	 return;
      }
      if (x<0.0)
      {
         _angle = -M_PI;
	 return;
      }
   }
   if (x==0.0)
   {
      if (y>0.0)
      {
         _angle = M_PI/2.0;
	 return;
      }
      if (y<0.0)
      {
         _angle = -M_PI/2.0;
	 return;
      }
   }

   _angle = atan2(y,x);
}

angle angle::operator+( angle &a2 )
{
    angle retval;
    
    retval._angle= _angle + a2._angle;
    retval.normalize();
    
    return retval;
}

/* angle       angle::operator+=( const angle& right)
{
    angle 	retval;
    
    retval.angle= angle + right.angle;
    retval.normalize();
    
    return retval;
}

angle       angle::operator+=( const double& right)
{
    angle 	retval;
    
    retval.angle= angle + right;
    retval.normalize();
    
    return retval;
}*/

angle& angle::operator+=( const angle& right)
{
    _angle= _angle + right._angle;
    normalize();
    
    return *this;
}

angle&       angle::operator+=( const double& right)
{
    _angle= _angle + right;
    normalize();
    
    return *this;
}

angle	angle::operator-( angle &a2 )
{
    angle retval;
    
    retval._angle= _angle - a2._angle;
    retval.normalize();
    
    return retval;
}

void angle::normalize(void)
{
    while( _angle <  -M_PI ) _angle += (2.0*M_PI);
    while( _angle >=  M_PI ) _angle -= (2.0*M_PI);
}

}
