#include "mesa_offscreen.h"

#ifdef HAVE_OPENGL

namespace mimas {

template<>
GLenum mesa_offscreen< rgba< unsigned char > >::getFormat(void) const
  throw (mimasexception)
{
#ifndef HAVE_OSMESA
  return GL_BGRA;
#else
  return OSMESA_BGRA;
#endif
}

template<>
GLenum mesa_offscreen< unsigned char >::getFormat(void) const
  throw (mimasexception)
{
#ifndef HAVE_OSMESA
  return GL_LUMINANCE;
#else
  MMERROR( false, mimasexception, , "OSMesa doesn't support off-screen "
	   "rendering on grey-scale images." );
  return 0;
#endif
}

template<>
void mesa_offscreen< rgba< unsigned char > >::setupColorScale(void) const
{
}

template<>
void mesa_offscreen< unsigned char >::setupColorScale(void) const
{
  double rwgt=0.3086;
  double gwgt=0.6094;
  double bwgt=0.0820;
  glPixelTransferf( GL_RED_SCALE, rwgt );
  glPixelTransferf( GL_GREEN_SCALE, gwgt );
  glPixelTransferf( GL_BLUE_SCALE, bwgt );
}

};

#endif

